Program LengyelformaKiertekeles;
 Uses
     Newdelay,Crt;
 Const
      Elemszam=70;
      MaxParSzam=10;
      Hiba : Array [0..13] of String[50] =
             ('Ez egy res kifejezs!',
              'Nem megengedett jel van a kifejezsben!',
              'Nem j alakban adta meg a szmot!',
              'Nem j helyen ll a szm!',
              'Nem j helyen all a "-"!',
              'Rossz helyen ll az opertor!',
              'Csak egy operandusa van az opertornak!',
              'Nem j helyen ll a fggvny!',
              'Rossz helyen ll a paramter!',
              'Rossz helyen van a nyit zarojel!',
              'Egy csuk zrjelnek nincs nyit prja!',
              'Nem j helyen van a csuk zrjel!',
              'Nincsnek prban a zrjelek!',
              'Opertorra nem vgzdhet egy kifejezs!');
      AlapOp='+-*/^ ~';
      FvSzam=15;
      IsmertFv : Array [1..FvSzam] of String[6] =
                 ('ABS','ARCTAN','COS','EE','EXP','FRAC','INT','LN','PI',
                  'RANDOM','ROUND','SQR','SQRT','SIN','TRUNC');
 Type
     parpar    = Record
                   parnev : String[6];
                   parert : Real;
                 End;
     paramlista = Record
                   pardb,
                   ismdb: Byte;
                   ertekek : Array [1..Maxparszam] of parpar;
                 End;

      elemtipus = (numkonst, operator, parameter, zarojel);

      elem = Record
               Case milyen: elemtipus of
                 numkonst : (szam: Real);
                 operator : (muv : String[6]);
                 parameter: (par : String[6]);
                 zarojel  : (zj  : Char);
               End;

     normkifejezes = Record
                       db     : Word;
                       elemek : Array [1..Elemszam] of elem;
                     End;

     lengykifejezes = Record
                         db     : Word;
                         elemek : Array [1..Elemszam] of elem;
                         eredkif: String;
                         parlist: paramlista;
                       End;
 Const
   Max1Elemszam=700;
   Max2Elemszam=30;
   fnev1='munka1.tmp';
   fnev2='munka2.tmp';
 Type
   pont     = Record
                x,y : Real;
              End;
   fgv1tipus = Array [1..Max1Elemszam] of pont;
   fgv2tipus = Array [1..Max2Elemszam,1..Max2Elemszam] of Real;

 Var
    kezdet       : String;
    tagoltalak   : normkifejezes;
    lengyelforma : lengykifejezes;
    helyes       : Boolean;
    hibaszam     : Word;
    f            : Text;
    eredmeny,x,y : Real;
    k            : Char;

   Procedure UjLap(cim : String);
     Const
        VizVon    = #205; FugVon    = #186;
        BalFelSar = #201; JobFelSar = #187;
        BalLeSar  = #200; JobLeSar  = #188;
     Var
        balveg,i : Integer;
   Begin
     Window(1,1,80,25); { a teljes kpernyre }
     balveg:=39-(Length(cim) div 2);
     ClrScr;
     TextBackground(DarkGray); TextColor(Blue); NormVideo;
     GotoXY( 1, 1); Write(BalFelSar); For i:=1 to 78 do Write(VizVon); Write(JobFelSar);
     GotoXY( 1,24); Write(BalLeSar);  For i:=1 to 78 do Write(VizVon); Write(JobLeSar);
     GotoXY( 1, 2); For i:=1 to 22 do Writeln(FugVon);
     For i:=1 to 22 do Begin GotoXY(80,i+1); Writeln(FugVon); End;
     GotoXY(30,25); Write('vege : Progam vge');
     HighVideo; GotoXY(balveg,1); Write((' '+cim+' '));
     Window(2,2,79,23);
   End; { UjLap }

 Function fvbekerdezes: String;
   Var s: String;
 Begin
   ujlap('Lengyelformra hozs');
   Writeln;
   Writeln('  Krem rjon be egy tetszleges kifejezst, vagy fggvnyt: ');
   Write('----> ');
   Readln(s);
   While pos(' ',s)>0 do delete(s,pos(' ',s),1);
   fvbekerdezes:=s;
 End; {fvbekerdezes}

 Function tagol(mit: String; Var tag: normkifejezes;
                             Var hibaszam: Word): Boolean;
   Var
      i,hossz: Word;
      zsz: Integer;
      hibas: Boolean;
      rs : String;
      milyenresz: elemtipus;
      tagtipus: elemtipus;

   Function szam(k: Char): Boolean;
   Begin
       szam:=(k in ['0'..'9','.']);
   End; {szam}

   Function  kovresz( mibol: String; Var honnan: Word;
                                     Var rossz: Boolean;
                                     Var hibaszam: Word) : String;
     Var kr : String;

     Function betu(k: Char): Boolean;
     Begin
         betu:=(k in ['a'..'z','A'..'Z']);
     End; {szam}
     Function specjel(k: Char): Boolean;
       Const
            spj = '-+*/^()';
     Begin
       specjel:=(pos(k,spj)>0);
     End;

   Begin
     kr:='';
     rossz:=false;
     If szam(mibol[honnan]) then
     Begin
       Repeat
         kr:=kr+mibol[honnan];
         honnan:=honnan+1;
       Until not(szam(mibol[honnan])) or (honnan>length(mibol));
     End {szam volt...}
     else
       If betu(mibol[honnan]) then
       Begin
         Repeat
           kr:=kr+upCase(mibol[honnan]);
           honnan:=honnan+1;
         Until not(betu(mibol[honnan])) or (honnan>length(mibol));
       End {betu volt...}
       else
         If specjel(mibol[honnan]) then
         Begin
           kr:=kr+mibol[honnan];
           honnan:=honnan+1;
         End {specialis jel volt...}
         else {hibas a kifejezes}
         Begin
           rossz:=true;
           hibaszam:=1;
         End;
     kovresz:=kr;
   End; {kovresz}

   Function tagellenorzes(mit: String; Var hibaszam: Word;
                                       Var elemtip: elemtipus): Boolean;

     Function fvnev(mi: String): Boolean;
       Var i: Word;
     Begin
       i:=1;
       While (i<=FvSzam) and (IsmertFv[i]<>mi) do
         i:=i+1;
       fvnev:=(i<=FvSzam);
     End; {nemfv}

     Procedure milyentag(mi: String; Var et: elemtipus);
     Begin
       If pos(mi[1],'-+*/^')>0 then et:=operator  else If
          fvnev(mi)            then et:=operator  else If
          mi[1] in ['(',')']   then et:=zarojel   else If
          mi[1] in ['A'..'Z']  then et:=parameter
              else                  et:=numkonst
       {End If};
     End; {milyentag}

     Function szamellenorzes(mit: String; Var hibaszam: Word): Boolean;
       Var
          rossz: Boolean;
          i,j  : Word;
       Begin
         i:=pos('.',mit);
         delete(mit,1,i);
         rossz:=((pos('.',mit)>0) or (length(mit)=0));
         hibaszam:=2;
         If not(rossz) then
         Begin
           With tagoltalak do
           Begin
             If db>0 then
             Begin
               rossz:=
               ((elemek[db].milyen=parameter) or
                (elemek[db].milyen=operator) and (length(elemek[db].muv)>1) or
                (elemek[db].milyen=zarojel) and (elemek[db].zj=')'));
               hibaszam:=3;
             End
             else rossz:=false;
           End; {With...}
         End; {if...}
         szamellenorzes:=rossz;
       End; {szamellen}

       Function operatorell(mi: String; Var hibaszam: Word): Boolean;
         Var rossz: Boolean;
       Begin
         With tagoltalak do
         Begin
           If mi[1]='-' then
           Begin
             If db>0 then
             Begin
               rossz:=
               ((elemek[db].milyen=operator) and
                ((length(elemek[db].muv)>1) or (elemek[db].muv='-')
                  or (elemek[db].muv='~')));
               hibaszam:=4;
             End
             else {elso helyen volt a minusz}
               rossz:=false;
           End
           else {nem kivonas}
            If length(mi)=1 then {nem fv.}
            Begin
              If db>0 then
              Begin
                rossz:=
                ((elemek[db].milyen=operator) or
                 (elemek[db].milyen=zarojel) and
                 (elemek[db].zj='('));
                hibaszam:=5;
              End
              else
              Begin
                rossz:=true;
                hibaszam:=6;
              End
            End
            else {fuggveny}
            Begin
              If db>0 then
              Begin
                rossz:=
                ((elemek[db].milyen=numkonst) or
                 (elemek[db].milyen=zarojel) and (elemek[db].zj=')'));
                hibaszam:=7;
              End
              else rossz:=false;
            End;
         End; {With...}
         operatorell:=rossz;
       End; {operator}

       Function parameterell(mit: String; Var hibaszam: Word): Boolean;
       Begin
         With tagoltalak do
         Begin
           If db>0 then
           Begin
             parameterell:=
             ((elemek[db].milyen=numkonst) or
              (elemek[db].milyen=zarojel) and (elemek[db].zj=')'));
             hibaszam:=8;
           End
           else
             parameterell:=false;
         End; {With...}
       End; {parameterell}

       Function zarojelell(mit: String; Var hibaszam: Word): Boolean;
         Var rossz: Boolean;
       Begin
         With tagoltalak do
         Begin
           If mit='(' then
           Begin
             If db>0 then
             Begin
               zarojelell:=
               ((elemek[db].milyen=numkonst) or
                (elemek[db].milyen=parameter) or
                (elemek[db].milyen=zarojel) and (elemek[db].zj=')'));
               hibaszam:=9;
             End
             else zarojelell:=false;
             zsz:=zsz+1;
           End
           else {csuko zarojel}
           Begin
             zsz:=zsz-1;
             rossz:=(zsz<0);
             hibaszam:=10;
             If not(rossz) then
             Begin
               rossz:=
               ((elemek[db].milyen=operator) or
                (elemek[db].milyen=zarojel) and (elemek[db].zj='('));
               hibaszam:=11;
             End;
             zarojelell:=rossz;
           End; {if...}
         End; {With...}
       End; {zarojelell}

   Begin {tagellenorzes}
     hibas:=false;
     milyentag(mit,elemtip);
     Case elemtip of
       numkonst : hibas:=szamellenorzes(mit,hibaszam);
       operator : hibas:=operatorell(mit,hibaszam);
       parameter: hibas:=parameterell(mit,hibaszam);
       zarojel  : hibas:=zarojelell(mit,hibaszam);
     End; {Case...}
     tagellenorzes:=hibas;
   End; {tagellenorzes}

   Procedure beillesztes(mit: String; Var hova: normkifejezes);
     Var
        aa: Word;

     Procedure unarisminusz(Var str: String; db: Word);
     Begin
       With tagoltalak do
       If str='-' then
       Begin
         If db=1 then
           str:='~'
         else
           If (elemek[db-1].milyen=operator) or (elemek[db-1].milyen=zarojel)
              then str:='~';
       End;
     End; {unarisminusz}

   Begin
     With tagoltalak do
     Begin
       db:=db+1;
       elemek[db].milyen:=tagtipus;
       Case tagtipus of
         numkonst : val(rs,elemek[db].szam,aa);
         operator : Begin
                      unarisminusz(rs,db);
                      elemek[db].muv:=rs;
                    End;
         parameter: elemek[db].par:=rs;
         zarojel  : elemek[db].zj :=rs[1];
       End; {Case...}
     End; {With...}
   End; {beillesztes}

 Begin  {tagol}
   hossz:=length(mit);
   hibas:=(hossz=0);
   hibaszam:=0;
   zsz:=0;
   i:=1;
   tagoltalak.db:=0;
   While (i<=hossz) and (not(hibas)) do
   Begin
       rs:=kovresz(mit,i,hibas,hibaszam);
       If not hibas then
       Begin
         If (rs='PI') or (rs='EE') or (rs='RANDOM') then
         Begin
           If rs='PI' then
               str(pi,rs)
           else
               If rs='EE' then
                 str(exp(1),rs)
               else
                 str(random,rs)
           {End If};
         End {If};
         hibas:=tagellenorzes(rs,hibaszam,tagtipus);
         If not(hibas) then beillesztes(rs,tagoltalak);
       End;
   End; {While...}
   If not(hibas) then Begin hibas:=(zsz<>0); hibaszam:=12; End;
   If not(hibas) then
   Begin
     hibas:=(tagtipus=operator);
     hibaszam:=13;
   End;
   tagol:=not(hibas);
 End; {tagol}

 Procedure lengyelformarahoz(mit: normkifejezes; Var lengy: lengykifejezes);
   Type
       veremmut  = ^veremelem;
       veremelem = Record
                     ertek : elem;
                     prior : 0..5;
                     mut   : veremmut;
                   End;
   Var
      i,hossz: Word;
      veremteto : veremmut;

   Procedure vereminic(Var vmut: veremmut);
   Begin
     new(vmut);
     vmut^.prior:=0;
   End;

   Function nemuresaverem: Boolean;
     Var t: Boolean;
   Begin
     t:=(veremteto^.prior<>0);
     nemuresaverem:=t;
   End;

   Procedure teton(vmut: veremmut; Var legfelso: veremelem);
  Begin
    legfelso:=vmut^;
   End;

   Procedure tetorol(Var legfelso: veremelem; Var vmut: veremmut);
     Var s: veremmut;
   Begin
     If vmut^.prior<>0 then
     Begin
       s:=vmut;
       legfelso:=vmut^;
       vmut:=s^.mut;
       dispose(s);
     End;
   End; {tetorol}

   Procedure verembe(mit: elem; prioritasa: Word; Var vmut: veremmut);
     Var s: veremmut;
   Begin
     new(s);
     s^.mut:=vmut;
     vmut:=s;
     vmut^.ertek:=mit;
     vmut^.prior:=prioritasa;
   End; {verembe}

   Procedure verembejaras(vmut: veremmut);
   Begin
     While vmut^.prior<>0 do
     Begin
       Case vmut^.ertek.milyen of
         numkonst : Write(vmut^.ertek.szam,' ');
         operator : Write(vmut^.ertek.muv,' ');
         parameter: Write(vmut^.ertek.par,' ');
       End; {Case...}
       vmut:=vmut^.mut;
     End; {While...}
     Writeln;
   End; {verembejaras}

   Procedure muvfeldolg(mi: elem; Var hossz: Word);
     Var
        pri: 0..5;
        legfelso: veremelem;

     Function prioritas(m: String): Word;
     Begin
       If length(m)>1 then  {fuggveny}
         prioritas:=5
       else
         prioritas:=((pos(m,AlapOp)+1) div 2)+1;
     End; {prioritas}

   Begin
     pri:=prioritas(mi.muv);
     Repeat
       teton(veremteto,legfelso);
       If pri<=legfelso.prior then
       Begin
         hossz:=hossz+1;
         tetorol(legfelso,veremteto);
         lengy.elemek[hossz]:=legfelso.ertek;
       End; {if...}
     Until pri>legfelso.prior;
     verembe(mi,pri,veremteto);
     {
     verembejaras(veremteto);
     }
   End; {muvfeldolg}

   Procedure zarojelfeld(mi: elem; Var hossz: Word);
     Var legfelso: veremelem;
   Begin
     If mi.zj='(' then
       verembe(mi,1,veremteto)
     else
       Repeat
         tetorol(legfelso,veremteto);
         If legfelso.ertek.zj<>'(' then
         Begin
           hossz:=hossz+1;
           lengy.elemek[hossz]:=legfelso.ertek
         End;
       Until legfelso.ertek.zj='(';
   End; {zarojelfeld}

   Procedure veremurites(Var hossz: Word; Var vmut: veremmut);
     Var legfelso: veremelem;
   Begin
     While vmut^.prior<>0 do
     Begin
       tetorol(legfelso,vmut);
       If legfelso.ertek.milyen<>zarojel then
       Begin
         hossz:=hossz+1;
         lengy.elemek[hossz]:=legfelso.ertek;
       End;
     End;
   End; {veremurites}

   Procedure parametergyujtes(Var lengy: lengykifejezes);
     Var
         i: Byte;
         pl: paramlista;
         vanx,vany: Boolean;

     Function megnincs(mi: String): Boolean;
       Var i: Byte;
     Begin
       i:=1;
       While (i<pl.pardb) and (pl.ertekek[i].parnev<>mi) do
         i:=i+1;
       megnincs:=(pl.ertekek[i].parnev<>mi);
     End; {megnincs}

   Begin
     With lengy do
     Begin
       vanx:=false; vany:=false;
       pl.pardb:=0;
       for i:=1 to lengy.db do
       Begin
         If elemek[i].milyen=parameter then
         Begin
           If (elemek[i].par='X') then vanx:=true;
           If (elemek[i].par='Y') then vany:=true;
           If megnincs(elemek[i].par) then
           Begin
             pl.pardb:=pl.pardb+1;
             pl.ertekek[pl.pardb].parnev:=elemek[i].par;
           End;
         End; {if...}
       End; {for...}
     pl.ismdb:=0;
     If vanx then pl.ismdb:=1;
     If vany then pl.ismdb:=pl.ismdb+1;
     parlist:=pl;
     End; {With...}
   End; {parametergyujtes}

   Procedure paramertekbekerd(Var pl: paramlista);
     Var
        i:Byte;
   Begin
     Writeln('A bert kifejezsben ',pl.pardb-pl.ismdb,' db paramter van.');
     Writeln('     Krem ezek rtkt:');
     for i:=1 to pl.pardb do
       With pl.ertekek[i] do
       Begin
         If (parnev<>'X') and (parnev<>'Y') then
         Begin
           Write('          ',parnev,':='); Readln(parert);
         End; {if...}
       End; {With...}
   End ; {paramertekbekerd}

   Procedure behelyettesit(Var mibe: lengykifejezes);
     Var
         i: Byte;
         r: Real;
         mit: paramlista;

     Function ertek(minek: String): Real;
     Begin
       i:=1;
       While minek<>mit.ertekek[i].parnev do i:=i+1;
       ertek:=mit.ertekek[i].parert
     End; {ertek}

   Begin
     mit:=mibe.parlist;
     for i:=1 to mibe.db do
       With mibe.elemek[i] do
         If (milyen=parameter) and (par<>'X') and (par<>'Y') then
           Begin
           r:=ertek(par);
           milyen:=numkonst;
           szam:=r;
         End; {if...With...for...}
   End; {behelyettesit}

 Begin
   With mit do
     Begin
     vereminic(veremteto);
     hossz:=0;
     i:=1;
     While i<=mit.db do
       Begin
       Case elemek[i].milyen of
         numkonst,
         parameter: Begin
                      hossz:=hossz+1;
                      lengy.elemek[hossz]:=elemek[i];
                    End;
         operator : muvfeldolg(elemek[i],hossz);
         zarojel  : zarojelfeld(elemek[i],hossz);
       End; {Case...}
       i:=i+1;
     End; {While...}
     veremurites(hossz,veremteto);
   End; {With...}
   lengy.db:=hossz;
   parametergyujtes(lengyelforma);
   If lengyelforma.parlist.pardb>lengyelforma.parlist.ismdb then
   Begin
     paramertekbekerd(lengyelforma.parlist);
     behelyettesit(lengyelforma);
   End;
 End; {lengyelformarahoz}


 Function kiertekel(lengy: lengykifejezes; x: Real; y: Real): Real;
   Type
       veremmut = ^lengyelverem;
       lengyelverem = Record
                        ertek :Real;
                        mut : veremmut;
                      End;
   Var
      paramlist : paramlista;
      veremteto : veremmut;
      i         : Integer;

   Procedure vereminic(Var vtet: veremmut);
   Begin
     vtet:=nil;
   End; {vereminic}

   Procedure verembe(mit: Real; Var vtet: veremmut);
     Var s:veremmut;
   Begin
     new(s);
     s^.ertek:=mit;
     s^.mut:=vtet;
     vtet:=s;
   End; {verembe}

   Function verembol(Var vtet: veremmut): Real;
     Var s: veremmut;
   Begin
     s:=vtet;
     verembol:=s^.ertek;
     vtet:=vtet^.mut;
     dispose(s);
   End; {verembol}

   Procedure parameterhelyettesites(x,y: Real; Var lengy: lengykifejezes);
     Var i: Integer;
         s: Real;
   Begin
     for i:=1 to lengy.db do
     Begin
       With lengy.elemek[i] do
         If milyen=parameter then
         Begin
           If par='X' then s:=x
                      else s:=y;
           milyen:=numkonst;
           szam:=s;
         End; {if...With...}
     End; {for...}
   End; {parameterhelyettesites}

   Procedure muveletelveg(muv: String; Var vtet: veremmut);
     Var
        a,b,c : Real;
   Begin
     { -+*/^   ket operandusu,
       ~ es a fuggvenyek egy-egy op.,}

     If pos(muv[1],'-+*/^')>=1 then
     Begin
       a:=verembol(vtet); b:=verembol(vtet);
       Case muv[1] of
         '-' : c:=b-a;
         '+' : c:=b+a;
         '*' : c:=b*a;
         '/' : c:=b/a;
         '^' : c:=exp(b*ln(a));
       End;
     End
     else {egyoperandusu}
     Begin
       a:=verembol(vtet);
       If muv='~'      then c:=-a        else if
          muv='ABS'    then c:=abs(a)    else if
          muv='ARCTAN' then c:=arctan(a) else if
          muv='COS'    then c:=cos(a)    else if
          muv='EXP'    then c:=exp(a)    else if
          muv='FRAC'   then c:=frac(a)   else if
          muv='INT'    then c:=int(a)    else if
          muv='LN'     then c:=ln(a)     else if
          muv='ROUND'  then c:=round(a)  else if
          muv='SQR'    then c:=sqr(a)    else if
          muv='SQRT'   then c:=sqrt(a)   else if
          muv='SIN'    then c:=sin(a)
             else           c:=trunc(a)
       {End If};
     End; {If...}
     verembe(c,vtet);
   End; {muveletelveg}

 Begin {kiertekel}
   vereminic(veremteto);
   parameterhelyettesites(x,y,lengy);
   for i:=1 to lengy.db do
   Begin
     With lengy.elemek[i] do
       If (milyen=numkonst) then
         verembe(szam,veremteto)
       else
         muveletelveg(muv,veremteto);
   End; {for...}
   kiertekel:=verembol(veremteto);
 End; {kiertekel}

 Procedure tagoltkifejezeskiir(tag: normkifejezes);
   Var i: Word;
 Begin
   Writeln;
   Writeln(' ');
   Writeln('     A tagokra szedett kifejezs ',tag.db,' elembl ll.');
   for i:=1 to tag.db do
     With tag.elemek[i] do
     Begin
       Case milyen of
         numkonst : Write(szam:5:2,' ');
         parameter: Write(par,' ');
         operator : Write(muv,' ');
         zarojel  : Write(zj,' ');
       End; {Case...}
     End; {With...}
   Writeln;
   Writeln;
 End; {tagoltkifejezeskiir}

 Procedure lengyelformakiir(lengy: lengykifejezes);
   Var i: Word;
 Begin
   Writeln;
   Writeln(' ');
   Writeln('     A lengyelformra hozott kifejezs : ',lengy.db,' tagbl ll.');
   Writeln;
   for i:=1 to lengy.db do
   Begin
     With lengy.elemek[i] do
       Case milyen of
         numkonst : Write(szam:5:2,' ');
         parameter: Write(par,' ');
         operator : Write(muv,' ');
       End; {With...}
   End; {for...}
   Writeln;
   With lengy.parlist do
     If ismdb>0 then
       Writeln(' A fggvny ',ismdb,' vltozs fv.')
     else
       Writeln(' A kifejezsben nincs fggetlen vltoz.');
   Writeln(' ');
 End; {lengyelformakiir}

 Procedure egyvaltozoskiertekeles(lengy: lengykifejezes);
   Var
      kezd,veg,lepes: Real;
      psz: Word;
      s: Real;
      f: Text;
 Begin
   Writeln('Krem adja meg az brzoland intervallum kezdett s vgt!');
   Repeat
     Write('    Kezdet :'); Readln(kezd);
     Write('    Vg    :'); Readln(veg);
   Until kezd<veg;
   Repeat
     Write('Hny db pontban szmoljunk fv.rtket?   psz(1< <=800!):='); Readln(psz);
   Until (psz>1) and (psz<=800);
   lepes:=(veg-kezd)/(psz-1);
   x:=kezd;
   Assign(f,fnev1);
   Rewrite(f);
   Writeln(f,psz);
   While x<=veg do
   Begin
     s:=kiertekel(lengy,x,0);
     Writeln('f(',x:5:2,')= ',s);
     Writeln(f,x);
     Writeln(f,s);
     x:=x+lepes;
   End; {While...}
   close(f);
 End; {egyvaltozoskiertekeles}

 Procedure ketvaltozoskiertekeles(lengy: lengykifejezes);
   Var
      xkezd,xveg,
      xlepes: Real;
      xpsz  : Word;
      ykezd,yveg,
      ylepes: Real;
      ypsz  : Word;
      s     : Real;
      f     : Text;
 Begin
   Writeln('Krem adja meg az brzoland tartomny adatait!');
   Repeat
     Write('   X Kezdet :'); Readln(xkezd);
     Write('   X Vg    :'); Readln(xveg);
   Until xkezd<xveg;
   Repeat
     Write('Az X tengely mentn hny db pontban szmoljunk fv.rtket? (<=30)');
     Write('   xpsz(>1!):='); Readln(xpsz);
   Until (xpsz>1) and (xpsz<=30);
   xlepes:=(xveg-xkezd)/(xpsz-1);
   Repeat
     Write('   Y Kezdet :'); Readln(ykezd);
     Write('   Y Vg    :'); Readln(yveg);
   Until ykezd<yveg;
   Repeat
     Write('Az Y tengely mentn hny db pontban szmoljunk fv.rtket? (<=30)');
     Write('   ypsz(>1!):='); Readln(ypsz);
   Until (ypsz>1) and (ypsz<=30);
   ylepes:=(yveg-ykezd)/(ypsz-1);
   y:=ykezd;
   assign(f,fnev2);
   rewrite(f);
   Writeln(f,xpsz);
   Writeln(f,ypsz);
   While y<=yveg do
   Begin
     x:=xkezd;
     While x<=xveg do
     Begin
       s:=kiertekel(lengy,x,y);
       Writeln('f(',x:5:2,',',y:5:2,')= ',s);
       Writeln(f,s);
       x:=x+xlepes;
     End; {While...}
     y:=y+ylepes;
   End; {While...}
   close(f);
 End; {ketvaltozoskiertekeles}

Begin {foprogram----}
  ClrScr;
  Randomize;
  Repeat
    kezdet:=fvbekerdezes;
    If kezdet<>'vege' then
    Begin
      helyes:=tagol(kezdet,tagoltalak,hibaszam);
      If helyes then
        Begin
        tagoltkifejezeskiir(tagoltalak);
        lengyelformarahoz(tagoltalak,lengyelforma);
        lengyelforma.eredkif:=kezdet;
        lengyelformakiir(lengyelforma);
        With lengyelforma.parlist do
	  Begin
          If ismdb=0 then  {konstans fv.}
            Writeln('eredmny:= ',kiertekel(lengyelforma,0,0))
          else
            If ismdb=1 then  {egyvaltozos fv.}
              egyvaltozoskiertekeles(lengyelforma)
            else
              ketvaltozoskiertekeles(lengyelforma);
        End; {With...}
      End
      else
        Writeln('Hibs kifejezs:  ',kezdet,'  <--',Hiba[hibaszam]);
      Window(1,1,80,25);
      gotoxy(25,25); Write('Nyomjon meg egy billentyt!');
      k:=ReadKey;
      ClrScr
    End; {if...}
  Until kezdet='vege';
  Window(1,1,80,25);
  ClrScr
End.